-- update the attachments counter (was not set for outgoing messages)
UPDATE mail SET attachments=(SELECT count(*) FROM attachments WHERE mail_id=mail.mail_id);

UPDATE trashed_mail SET attachments=(SELECT count(*) FROM attachments WHERE mail_id=trashed_mail.mail_id);

ALTER TABLE attachments ADD charset VARCHAR(30);

CREATE TABLE mail_words (
 mail_id int,
 word_id int
);
CREATE INDEX mw_word_idx ON mail_words(word_id);

CREATE TABLE words (
 word_id int,
 wordtext varchar(30)
);
CREATE UNIQUE INDEX wordtext_idx ON words(wordtext);

CREATE SEQUENCE seq_word_id;

CREATE TABLE word_indexed_mail (
 mail_id int
);

ALTER TABLE addresses ADD nb_recv_from INT;
ALTER TABLE addresses ADD nb_sent_to INT;

CREATE TABLE mime_types (
 suffix varchar(20) NOT NULL,
 mime_type varchar(100) NOT NULL
);

INSERT INTO runtime_info(rt_key,rt_value) VALUES ('schema_version','0.9.4');

-- delete undesirable multiple tag entries
DELETE FROM mail_tags WHERE oid IN
  (SELECT mt1.oid FROM mail_tags mt1, mail_tags mt2 WHERE
    mt1.mail_id=mt2.mail_id AND mt1.tag=mt2.tag AND 
    mt1.oid>mt2.oid);


DROP INDEX idx_Mail_Tags_mail_id;
CREATE UNIQUE INDEX mail_tags_idx ON mail_tags(mail_id,tag);

INSERT INTO config(conf_key,value,conf_name) 
 SELECT 'default_identity', value, conf_name FROM config
   WHERE conf_key='email';

CREATE TABLE non_indexable_words (
  wordtext varchar(30)
);

CREATE TABLE identities (
  email_addr varchar(200) NOT NULL,
  username varchar(200),
  xface varchar(2000),
  signature text
);

CREATE TABLE mailboxes (
 mbox_id integer primary key,
 name varchar(200)
);
CREATE UNIQUE INDEX mbox_name ON mailboxes(name);

CREATE TABLE filter_expr (
  expr_id int PRIMARY KEY,
  name varchar(100),
  user_lastmod int,
  last_update timestamptz default now(),
  expr_ordrer int,
  expression text
);
CREATE UNIQUE INDEX expr_idx ON filter_expr(name);

CREATE TABLE filter_action (
 expr_id int,
 action_order smallint,
 action_arg text,
 action_type varchar(100)
);
CREATE UNIQUE INDEX filter_action_idx ON filter_action(expr_id,action_order);

CREATE TABLE user_queries (
 title varchar(100) PRIMARY KEY,
 sql_stmt text
);

ALTER TABLE tags ADD parent_id INT;
