-- Run this script to upgrade a manitou database schema
-- from v-0.9.6 to v-0.9.7

BEGIN;

DROP TABLE raw_mail; -- wasn't used before
CREATE TABLE raw_mail (
  mail_id int,
  mail_text oid
);
CREATE UNIQUE INDEX idx_raw_mail ON raw_mail(mail_id);

CREATE TABLE inverted_word_index (
 word_id int,
 part_no int,
 mailvec bytea,
 nz_offset int default 0
);
CREATE UNIQUE INDEX iwi_idx ON inverted_word_index(word_id,part_no);

CREATE TABLE jobs_queue (
 job_id serial,
 mail_id int,
 job_type varchar(4),
 job_args text
);
CREATE UNIQUE INDEX jobs_pk_idx ON jobs_queue(job_id);


-- Changing the column type works only for 8.x+, so we recreate instead
-- ALTER TABLE words ALTER COLUMN wordtext TYPE varchar(50);
DROP TABLE words;
CREATE TABLE words (
 word_id int,
 wordtext varchar(50)
);
CREATE UNIQUE INDEX wordtext_idx ON words(wordtext);

DROP TABLE mail_words;

DROP INDEX mail_msg_day_idx;
CREATE INDEX mail_date_idx ON mail(msg_date);

UPDATE runtime_info SET rt_value='0.9.7' WHERE rt_key='schema_version';

COMMIT;
